######################################################################
# OpenLedger - Customer.pm (class)
# Copyright (C) 2005
#
#  Author: Klavs Klavsen
#   Email: kl@vsen.dk
#     Web: http://www.vsen.dk
#
#  Contributors to this file:
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#######################################################################
package Customer;

use strict;
use vars qw($VERSION);

$VERSION = "0.1";
sub Version { $VERSION }
my $user;
#constructor
sub new 
{
    my ($class,$userobj) = @_;
    my $self = 
    {
     #   _custnr  => undef,
     #   _custname  => undef,
	#_custaddr => undef,
	#_custaddr2 => undef,
	#_custzip => undef,
	#_custcity => undef,
	#_custcountry => undef,
	
    };
    $user=$userobj;
    bless $self, $class;
    return $self;
}
 #            customernumber = |.$dbh->quote($form->{customernumber}).qq|,
#	      name = |.$dbh->quote($form->{name}).qq|,
#	      address1 = |.$dbh->quote($form->{address1}).qq|,
#	      address2 = |.$dbh->quote($form->{address2}).qq|,
#	      city = |.$dbh->quote($form->{city}).qq|,
#	      state = |.$dbh->quote($form->{state}).qq|,
#	      zipcode = |.$dbh->quote($form->{zipcode}).qq|,
#	      country = |.$dbh->quote($form->{country}).qq|,
#	      contact = |.$dbh->quote($form->{contact}).qq|,
#	      phone = '$form->{phone}',
#	      fax = '$form->{fax}',
#	      email = '$form->{email}',
#	      cc = '$form->{cc}',
#	      bcc = '$form->{bcc}',
#	      notes = |.$dbh->quote($form->{notes}).qq|,
#	      discount = $form->{discount},
#	      creditlimit = $form->{creditlimit},
#	      terms = $form->{terms},
#	      taxincluded = '$form->{taxincluded}',
#	      business_id = $business_id,
#	      taxnumber = |.$dbh->quote($form->{taxnumber}).qq|,
#	      sic_code = '$form->{sic_code}',
#	      iban = '$form->{iban}',
#	      bic = '$form->{bic}',
#	      employee_id = $employee_id,
#	      pricegroup_id = $pricegroup_id,
#	      language_code = '$language_code',
##	      curr = '$form->{curr}',
#	      startdate = |.$form->dbquote($form->{startdate}, SQL_DATE).qq|,
#	      enddate = |.$form->dbquote($form->{enddate}, SQL_DATE).qq|

#accessor methods for InvoiceLine 
#sub custNr {
#    my ( $self, $custNr ) = @_;
#    if (defined($custNr))
#    { $self->{_custnr} = $custNr; }
#    return $self->{_custnr};
#}
#sub custName {
#    my ( $self, $custName ) = @_;
#    if (defined($custName))
#    { $self->{_custname} = $custName; }
#    return $self->{_custname};
#}
#sub custAddr {
#    my ( $self, $custAddr ) = @_;
##    $self->{_custaddr} = $custAddr if defined($custAddr);
#    return $self->{_custaddr};
#}
#sub custAddr2 {
#    my ( $self, $custAddr2 ) = @_;
#    $self->{_custaddr2} = $custAddr2 if defined($custAddr2);
#    return $self->{_custaddr2};
#}
#sub custZip {
#    my ( $self, $custZip ) = @_;
#    $self->{_custzip} = $custZip if defined($custZip);
#    return $self->{_custzip};
#}
#sub custCity {
#    my ( $self, $custCity ) = @_;
#    $self->{_custcity} = $custCity if defined($custCity);
#    return $self->{_custcity};
#}
#sub custCountry {
#    my ( $self, $custCountry ) = @_;
#    $self->{_custcountry} = $custCountry if defined($custCountry);
#    return $self->{_custcountry};
#} 


sub save_customer {
  my ($self) = @_;

  # connect to database
  my $dbh = $user->dbconnect_noauto();
  my $query;
  my $sth;
  my $null;
  
  # remove double spaces
  $self->{name} =~ s/  / /g;
  # remove double minus and minus at the end
  $self->{name} =~ s/--+/-/g;
  $self->{name} =~ s/-+$//;
  
  # assign value discount, terms, creditlimit
  $self->{discount} = $user->parse_amount( $self->{discount});
  $self->{discount} /= 100;
  $self->{terms} *= 1;
  $self->{taxincluded} *= 1;
  $self->{creditlimit} = $user->parse_amount( $self->{creditlimit});
  

  if ($self->{id}) {
    $query = qq|DELETE FROM customertax
                WHERE customer_id = $self->{id}|;
    $dbh->do($query) || return -6;

    $query = qq|DELETE FROM shipto
                WHERE trans_id = $self->{id}|;
    $dbh->do($query) || return -6;

    # retrieve enddate
    if ($self->{type} && $self->{enddate}) {
      my $now;
      $query = qq|SELECT enddate, current_date AS now FROM customer|;
      ($self->{enddate}, $now) = $dbh->selectrow_array($query);
      $self->{enddate} = $now if $self->{enddate} lt $now;
    }

  } else {
    my $uid = time;
    $uid .= $user->{login};

    $query = qq|INSERT INTO customer (name)
                VALUES ('$uid')|;
    $dbh->do($query) || return -6;
    
    $query = qq|SELECT id FROM customer
                WHERE name = '$uid'|;
    $sth = $dbh->prepare($query);
    $sth->execute || return -6;

    ($self->{id}) = $sth->fetchrow_array;
    $sth->finish;

  }

  my $employee_id;
  ($null, $employee_id) = split /--/, $self->{employee};
  $employee_id *= 1;
  
  my $pricegroup_id;
  ($null, $pricegroup_id) = split /--/, $self->{pricegroup};
  $pricegroup_id *= 1;

  my $business_id;
  ($null, $business_id) = split /--/, $self->{business};
  $business_id *= 1;

  my $language_code;
  ($null, $language_code) = split /--/, $self->{language};

  $self->{customernumber} = $user->update_defaults( "customernumber", $dbh) if ! $self->{customernumber};
  
  $query = qq|UPDATE customer SET
              customernumber = |.$dbh->quote($self->{customernumber}).qq|,
	      name = |.$dbh->quote($self->{name}).qq|,
	      address1 = |.$dbh->quote($self->{address1}).qq|,
	      address2 = |.$dbh->quote($self->{address2}).qq|,
	      city = |.$dbh->quote($self->{city}).qq|,
	      state = |.$dbh->quote($self->{state}).qq|,
	      zipcode = |.$dbh->quote($self->{zipcode}).qq|,
	      country = |.$dbh->quote($self->{country}).qq|,
	      contact = |.$dbh->quote($self->{contact}).qq|,
	      phone = '$self->{phone}',
	      fax = '$self->{fax}',
	      email = '$self->{email}',
	      cc = '$self->{cc}',
	      bcc = '$self->{bcc}',
	      notes = |.$dbh->quote($self->{notes}).qq|,
	      discount = $self->{discount},
	      creditlimit = $self->{creditlimit},
	      terms = $self->{terms},
	      taxincluded = '$self->{taxincluded}',
	      business_id = $business_id,
	      taxnumber = |.$dbh->quote($self->{taxnumber}).qq|,
	      sic_code = '$self->{sic_code}',
	      iban = '$self->{iban}',
	      bic = '$self->{bic}',
	      employee_id = $employee_id,
	      pricegroup_id = $pricegroup_id,
	      language_code = '$language_code',
	      curr = '$self->{curr}',
	      startdate = |.$user->dbquote($self->{startdate}, "SQL_DATE").qq|,
	      enddate = |.$user->dbquote($self->{enddate}, "SQL_DATE").qq|
	      WHERE id = $self->{id}|;
  $dbh->do($query) ||return -6;

  # save taxes
  foreach my $item (split / /, $self->{taxaccounts}) {
    if ($self->{"tax_$item"}) {
      $query = qq|INSERT INTO customertax (customer_id, chart_id)
		  VALUES ($self->{id}, (SELECT id
				        FROM chart
				        WHERE accno = '$item'))|;
      $dbh->do($query) || return -6;
    }
  }
  
  # add shipto
  &add_shipto($dbh, $self->{id});

  $dbh->commit;
  $dbh->disconnect;

}
sub add_shipto {
  my ($self, $dbh, $id) = @_;

  my $shipto;
  foreach my $item (qw(name address1 address2 city state zipcode country contact phone fax email)) {
    if ($self->{"shipto$item"} ne "") {
      $shipto = 1 if ($self->{$item} ne $self->{"shipto$item"});
    }
  }

  if ($shipto) {
    my $query = qq|INSERT INTO shipto (trans_id, shiptoname, shiptoaddress1,
                   shiptoaddress2, shiptocity, shiptostate,
		   shiptozipcode, shiptocountry, shiptocontact,
		   shiptophone, shiptofax, shiptoemail) VALUES ($id, |
		   .$dbh->quote($self->{shiptoname}).qq|, |
		   .$dbh->quote($self->{shiptoaddress1}).qq|, |
		   .$dbh->quote($self->{shiptoaddress2}).qq|, |
		   .$dbh->quote($self->{shiptocity}).qq|, |
		   .$dbh->quote($self->{shiptostate}).qq|, |
		   .$dbh->quote($self->{shiptozipcode}).qq|, |
		   .$dbh->quote($self->{shiptocountry}).qq|, |
		   .$dbh->quote($self->{shiptocontact}).qq|,
		   '$self->{shiptophone}', '$self->{shiptofax}',
		   '$self->{shiptoemail}')|;
    $dbh->do($query) || $self->dberror($query);
  }

}

1;