

######################################################################
# OpenLedger - OpenLedger.pm (class)
# Copyright (C) 2005
#
#  Author: Klavs Klavsen
#   Email: kl@vsen.dk
#     Web: http://www.vsen.dk
#
#  Contributors to this file:
#  Dieter Simader - reused some code from SQL-Ledger project, written by Dieter.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#######################################################################
package OpenLedger;

use strict;
use warnings;
use vars qw($VERSION);
use lib '/www/customers/shared/perllib';
use DBI();
use DateTime::Format::Strptime;
use DateTime::Format::DateManip;
#use Transaction; 
#use Invoice;    
#use Item;   
use Customer; 
use Data::Dumper;
use USER;
use LOCALE;

$VERSION = "0.1";
sub Version { $VERSION }

###modified by Ang Tun Chek
my   $memberfile = "users/members";
my $userspath = "users";
my $db;
my $errno;

###end modified by Ang Tun Chek


#constructor
sub new 
{
      
    my ($class,$username, $password,$dbv) = @_;
    my $self = 
    {
        _hash  => undef,
       # _username  => undef,
	_db => undef,
	_user => new USER ($memberfile, $username),
	_dbversion=> $dbv,
	_memberfile=>$memberfile,
	_userspath=>$userspath,
	_customer=>undef,
   };
   
   #hacked in for now. Needs to be put in config file
    #my $dbname='sqlledger'; my $dbhost='localhost';my $dbuser='sql-ledger';my $dbpass='sqlledger';
  
  # connect to database, turn off AutoCommit
  #  $self->{_db} = DBI->connect("DBI:Pg:dbname=$dbname;host=$dbhost", "$dbuser","$dbpass",{'RaiseError' => 1, 'AutoCommit' => 0});
 if(( $errno =&Login($self,$password)) < 0){
      print "login failed \n";
      print "error number : $errno \n";
      delete $self->{_user};
#########################
#  Login Error Code
#    1 - Incorrect Password!
#    2 - Incorrect Dataset version!
#    3 - this useris not a member!
#    4 - Dataset is newer than version!
#    5 - Upgrading Database
#    6 - database error
##################
 
    }else{
       print "login success\n";
    }
  
    bless $self, $class;
    return $self;
}

sub new_customer{
	my ( $self ) = @_;
	$self->{_customer}= new Customer($self->{_user});
}

#destructor
sub DESTROY {
    my $self = shift;
   # $self->{_db}->disconnect();
  
}

#Takes a date object and returns false if the date in question is within a closed period.
# closed periods MAY NEVER be altered - and thus this function needs to be
# called from every function, before altering anything.
sub isClosed {
  #SL setup is a date field in defaults, field is called: closedto

  #Hack - for now it just returns true
  return 1;
}

#accessor methods for Transaction 


sub Login {
    my ( $self, $password ) = @_;

   # if we get an error back, bale out
  if (($errno = $self->{_user}->login($password, $userspath,$self->{_dbversion})) <= -1) {

   # $errno *= -1;
  #print "$errno dfdfdfd\n";
   return $errno;
  }
  #  map { $db->{$_} = $user->{$_} } qw(dbname dbhost dbport dbdriver dbuser dbpasswd);
  # print "login success\n";
}


sub Logout {
    my ( $self, $hash ) = @_;
    #$self->{_username} = ''; #perhaps there's an undef function?
   # $self->{_hash} = ''; #perhaps there's an undef function?
   delete $self->{_user};
}

# This function WILL be extended to support posting any transaction (invoices
# etc.) - but for now it only supports a normal "general ledger" transaction -
# no fancy stuff, like source, fx_transaction and project_id fields support.
sub postTransaction {
  my ($self, $transaction, $loginhash) = @_;
  #$loginhash contains a hash, which if correct matches a username(ie. an employee)

  # HACK
  # Skip login section - loginhash = username !!!!!
  # !!!!!!!!!!!!
  $self->{_username} = $loginhash;

  #ensure the transaction date is outside of closed periods
  #should be changed to simply skip the rest of function and return 1 and set some error field with info of why it failed!
  return 1 if isClosed($transaction->transactionDate());
  
  # post the transaction
  # make up a unique handle and store in reference field
  # then retrieve the record based on the unique handle to get the id
  # replace the reference field with the actual variable
  # add records to acc_trans

  my $query; my $error = 0;
  my $sth;
  my $uid = time . $self->{_username};

  $sth = $self->{_db}->prepare("INSERT INTO gl (reference, employee_id) VALUES (?, (SELECT id FROM employee WHERE login = ?))");
  $sth->execute($uid,$self->{_username});
  
  $sth = $self->{_db}->prepare("SELECT id FROM gl WHERE reference = ?");
  $sth->execute($uid);
 
  ($uid) = $sth->fetchrow_array;
  $sth->finish;
 
  #($null, $department_id) = split /--/, $form->{department};
  #$department_id *= 1;
  #don't know what department_id is - is 0 in my own db. ??
  #HACK - set to 0
  my $department_id = 0; my $rc;
  
  $sth = $self->{_db}->prepare("UPDATE gl SET reference = ?, description = ?, notes = ?, transdate = ?, department_id = ? WHERE id = ?");
  $sth->execute($transaction->reference(),$transaction->description(),$transaction->notes(),$transaction->transactionDate(),$department_id,$uid);
  $error = 1 if( $@ );

  #HACK: need to write config class which has the lang config.
  #hardcode conversion from "dk settings" to english settings
  my $x = new Number::Format(thousands_sep   => '.',
                              decimal_point   => ',',
			      decimal_fill    => '1');
  # HACK! there's no project ID/fx_transaction/source to select in the SL GUI - so I'm setting project ID to null.
  my $projectnumber = '0'; 
  my $fx_transaction = '0';
  my $source = '0'; my $i; my $amount=0; my $tmpamount;
  # insert acc_trans transactions
  for $i (1 .. $transaction->getTransactionLinesAmount() -1) 
  {
     # get the transaction line
     my ($accno,$debit,$credit) = $transaction->getTransactionLine($i);
     $amount = $amount + $credit - $debit; $tmpamount = $credit - $debit;
     # add the record 
     $sth = $self->{_db}->prepare("INSERT INTO acc_trans (trans_id, chart_id, amount, transdate, source, project_id, fx_transaction) VALUES (?, (SELECT id FROM chart WHERE accno = ?), ?, ?, ?, ?, ?)");
     $sth->execute($uid,$accno,$tmpamount,$transaction->transactionDate(),$source,$projectnumber,$fx_transaction);
     $error = 1 if( $@ );
     print "Added trans linenr. $i\n";
  }
  if( $error ) {
    warn "Database error: $DBI::errstr\n";
    print "\nDid Rollback\n";
    $rc = $self->{_db}->rollback(); #just die if rollback is failing
  }
  # VALIDATE that debit and credit is equal, by verifying $amount is 0! 
  #$rc = $self->{_db}->rollback if ($amount != 1);
  
  my %audittrail = ( tablename  => 'gl',
                     reference  => $transaction->reference(),
		     formname   => 'transaction',
		     action     => 'posted',
		     id         => $uid );
  $self->audittrail(\%audittrail) if (!$error);

  # commit and redirect
  $rc = $self->{_db}->commit if (!$error);
  print "rc:$rc\n";
  $rc;

}

sub audittrail {
  my ($self, $audittrail) = @_;
  
  my $query;
  my $rv;

  # Audittrail table in my SL is empty - it apperantly needs to be enabled.
  # I'll simply comment out this code for now - let someone who needs it,
  # convert it.

  # if we have an id add audittrail, otherwise get a new timestamp
  
#  if ($audittrail->{id}) {
#    $dbh = $self->dbconnect($myconfig) if $myconfig;
#    
#    $query = qq|SELECT audittrail FROM defaults|;
#    
#    if ($dbh->selectrow_array($query)) {
#      my ($null, $employee_id) = $self->get_employee($dbh);
#
#      if ($self->{audittrail} && !$myconfig) {
#	chop $self->{audittrail};
#	
#	my @a = split /\|/, $self->{audittrail};
#	my %newtrail = ();
#	my $key;
#	my $i;
#	my @flds = qw(tablename reference formname action transdate);
#
#	# put into hash and remove dups
#	while (@a) {
#	  $key = "$a[2]$a[3]";
#	  $i = 0;
#	  $newtrail{$key} = { map { $_ => $a[$i++] } @flds };
#	  splice @a, 0, 5;
#	}
#	
#	$query = qq|INSERT INTO audittrail (trans_id, tablename, reference,
#		    formname, action, employee_id, transdate)
#	            VALUES ($audittrail->{id}, ?, ?,
#		    ?, ?, $employee_id, ?)|;
#	my $sth = $dbh->prepare($query) || $self->dberror($query);
#
#	foreach $key (sort { $newtrail{$a}{transdate} cmp $newtrail{$b}{transdate} } keys %newtrail) {
#	  $i = 1;
#	  map { $sth->bind_param($i++, $newtrail{$key}{$_}) } @flds;
#
#	  $sth->execute || $self->dberror;
#	  $sth->finish;
#	}
#      }
#
#     
#      if ($audittrail->{transdate}) {
#	$query = qq|INSERT INTO audittrail (trans_id, tablename, reference,
#		    formname, action, employee_id, transdate) VALUES (
#		    $audittrail->{id}, '$audittrail->{tablename}', |
#		    .$dbh->quote($audittrail->{reference}).qq|',
#		    '$audittrail->{formname}', '$audittrail->{action}',
#		    $employee_id, '$audittrail->{transdate}')|;
#      } else {
#	$query = qq|INSERT INTO audittrail (trans_id, tablename, reference,
#		    formname, action, employee_id) VALUES ($audittrail->{id},
#		    '$audittrail->{tablename}', |
#		    .$dbh->quote($audittrail->{reference}).qq|,
#		    '$audittrail->{formname}', '$audittrail->{action}',
#		    $employee_id)|;
#      }
#      $dbh->do($query);
#    }
#  } else {
#    $dbh = $self->dbconnect($myconfig);
#    
#    $query = qq|SELECT current_timestamp FROM defaults|;
#    my ($timestamp) = $dbh->selectrow_array($query);
#
#    $rv = "$audittrail->{tablename}|$audittrail->{reference}|$audittrail->{formname}|$audittrail->{action}|$timestamp|";
#  }
#
#  $dbh->disconnect if $myconfig;
  
  $rv;
  
}

#sub searchDebitorInvoices {
#  my ($self, $searchparams) = @_; 
#
#  my $paid = "a.paid";
#  
#  ($form->{transdatefrom}, $form->{transdateto}) = $form->from_to($form->{year}, $form->{month}, $form->{interval}) if $form->{year} && $form->{month};
# 
#  if ($form->{outstanding}) {
#    $paid = qq|SELECT SUM(ac.amount) * -1
#               FROM acc_trans ac
#	       JOIN chart c ON (c.id = ac.chart_id)
#	       WHERE ac.trans_id = a.id
#	       AND (c.link LIKE '%AR_paid%' OR c.link = '')|;
#    $paid .= qq|
#               AND ac.transdate <= '$form->{transdateto}'| if $form->{transdateto};
#  }
#
#  my $query = qq|SELECT a.id, a.invnumber, a.ordnumber, a.transdate,
#                 a.duedate, a.netamount, a.amount, ($paid) AS paid,
#		 a.invoice, a.datepaid, a.terms, a.notes,
#		 a.shipvia, a.shippingpoint, e.name AS employee, c.name,
#		 a.customer_id, a.till, m.name AS manager, a.curr,
#		 ex.buy AS exchangerate
#	         FROM ar a
#	      JOIN customer c ON (a.customer_id = c.id)
#	      LEFT JOIN employee e ON (a.employee_id = e.id)
#	      LEFT JOIN employee m ON (e.managerid = m.id)
#	      LEFT JOIN exchangerate ex ON (ex.curr = a.curr
#	                                    AND ex.transdate = a.transdate)
#	      |;
#
#  my %ordinal = ( 'id' => 1,
#                  'invnumber' => 2,
#		  'ordnumber' => 3,
#		  'transdate' => 4,
#		  'duedate' => 5,
#		  'datepaid' => 10,
#		  'shipvia' => 13,
#		  'shippingpoint' => 14,
#		  'employee' => 15,
#		  'name' => 16,
#		  'manager' => 19,
#		  'curr' => 20
#		);
#
#  
#  my @a = (transdate, invnumber, name);
#  push @a, "employee" if $form->{l_employee};
#  push @a, "manager" if $form->{l_manager};
#  my $sortorder = $form->sort_order(\@a, \%ordinal);
#  
#  my $where = "1 = 1";
#  if ($form->{customer_id}) {
#    $where .= " AND a.customer_id = $form->{customer_id}";
#  } else {
#    if ($form->{customer}) {
#      $var = $form->like(lc $form->{customer});
#      $where .= " AND lower(c.name) LIKE '$var'";
#    }
#  }
#  if ($form->{department}) {
#    my ($null, $department_id) = split /--/, $form->{department};
#    $where .= " AND a.department_id = $department_id";
#  }
#  if ($form->{invnumber}) {
#    $var = $form->like(lc $form->{invnumber});
#    $where .= " AND lower(a.invnumber) LIKE '$var'";
#    $form->{open} = $form->{closed} = 0;
#  }
#  if ($form->{ordnumber}) {
#    $var = $form->like(lc $form->{ordnumber});
#    $where .= " AND lower(a.ordnumber) LIKE '$var'";
#    $form->{open} = $form->{closed} = 0;
#  }
#  if ($form->{shipvia}) {
#    $var = $form->like(lc $form->{shipvia});
#    $where .= " AND lower(a.shipvia) LIKE '$var'";
#  }
#  if ($form->{notes}) {
#    $var = $form->like(lc $form->{notes});
#    $where .= " AND lower(a.notes) LIKE '$var'";
#  }
# 
#  $where .= " AND a.transdate >= '$form->{transdatefrom}'" if $form->{transdatefrom};
#  $where .= " AND a.transdate <= '$form->{transdateto}'" if $form->{transdateto};
#  if ($form->{open} || $form->{closed}) {
#    unless ($form->{open} && $form->{closed}) {
#      $where .= " AND a.amount != a.paid" if ($form->{open});
#      $where .= " AND a.amount = a.paid" if ($form->{closed});
#    }
#  }
#
#  if ($form->{till}) {
#    $where .= " AND a.invoice = '1'
#                AND NOT a.till IS NULL";
#    if ($myconfig->{role} eq 'user') {
#      $where .= " AND e.login = '$form->{login}'";
#    }
#  }
#
#  if ($form->{AR}) {
#    my ($accno) = split /--/, $form->{AR};
#    $where .= qq|
#                AND a.id IN (SELECT ac.trans_id
#		             FROM acc_trans ac
#			     JOIN chart c ON (c.id = ac.chart_id)
#			     WHERE a.id = ac.trans_id
#			     AND c.accno = '$accno')
#		|;
#  }
#  
#  $query .= "WHERE $where
#             ORDER by $sortorder";
#
#  my $sth = $dbh->prepare($query);
#  $sth->execute || $form->dberror($query);
#
#  while (my $ref = $sth->fetchrow_hashref(NAME_lc)) {
#    $ref->{exchangerate} = 1 unless $ref->{exchangerate};
#    if ($form->{outstanding}) {
#      next if $form->round_amount($ref->{amount}, 2) == $form->round_amount($ref->{paid}, 2);
#    }
#    push @{ $form->{transactions} }, $ref;
#  }
#  
#  $sth->finish;
#  $dbh->disconnect;
#
#}

#For getting a specific invoice - need to specifiy the invoicenumber 
# DebitorInvoice = AR table
sub getDebitorInvoice {
  my ($self, $invoicenr) = @_; 
  my $sth; my $rc;
  my $invoice =  eval { new Invoice(); }  or die ($@);

  # retrieve invoice
  $sth = $self->{_db}->prepare("SELECT a.invnumber, a.ordnumber, a.quonumber,
              a.transdate, a.paid,
              a.shippingpoint, a.shipvia, a.terms, a.notes, a.intnotes, a.duedate, a.taxincluded, a.curr AS currency,
		a.employee_id, e.name AS employee, a.till, a.customer_id,
		a.language_code
		FROM ar a
	        LEFT JOIN employee e ON (e.id = a.employee_id)
		WHERE a.invnumber = ?");
  $sth->execute($invoicenr);
   
  my $ref = $sth->fetchrow_hashref;
  #map { $form->{$_} = $ref->{$_} } keys %$ref;
  # HACK - need to write map function for Invoice object or think of something
  # clever :)

  my $parser = DateTime::Format::Strptime->new( pattern => '%y-%m-%d' );
  $invoice->invoiceNr($invoicenr); $invoice->orderNr($ref->{ordnumber});
  $invoice->invoiceDate($parser->parse_datetime($ref->{transdate}));
  $invoice->paidTotal($ref->{paid}); $invoice->notes($ref->{notes});
  $invoice->intNotes($ref->{intnotes});
  $sth->finish;

  # get shipto
#  $query = qq|SELECT * FROM shipto
#              WHERE trans_id = $form->{id}|;
#  $sth = $dbh->prepare($query);
#  $sth->execute || $form->dberror($query);
#
#  $ref = $sth->fetchrow_hashref(NAME_lc);
#  map { $form->{$_} = $ref->{$_} } keys %$ref;
#  $sth->finish;
#
#  # retrieve individual items
#  $query = qq|SELECT (SELECT c.accno FROM chart c
#                     WHERE p.inventory_accno_id = c.id)
#                     AS inventory_accno,
#		       (SELECT c.accno FROM chart c
#		       WHERE p.income_accno_id = c.id)
#		       AS income_accno,
#		       (SELECT c.accno FROM chart c
#		       WHERE p.expense_accno_id = c.id)
#		       AS expense_accno,
#              i.description, i.qty, i.fxsellprice, i.sellprice,
#		i.discount, i.parts_id AS id, i.unit, i.deliverydate,
#		i.project_id, pr.projectnumber, i.serialnumber,
#		p.partnumber, p.assembly, p.bin,
#		pg.partsgroup, p.partsgroup_id, p.partnumber AS sku,
#		p.listprice, p.lastcost, p.weight,
#		t.description AS partsgrouptranslation
#		FROM invoice i
#	        JOIN parts p ON (i.parts_id = p.id)
#	        LEFT JOIN project pr ON (i.project_id = pr.id)
#	        LEFT JOIN partsgroup pg ON (p.partsgroup_id = pg.id)
#		LEFT JOIN translation t ON (t.trans_id = p.partsgroup_id AND t.language_code = '$form->{language_code}')
#		WHERE i.trans_id = $form->{id}
#		AND NOT i.assemblyitem = '1'
#		ORDER BY i.id|;
#  $sth = $dbh->prepare($query);
#  $sth->execute || $form->dberror($query);
#
#  # foreign currency
#  &exchangerate_defaults($dbh, $form);
#
#  # query for price matrix
#  my $pmh = &price_matrix_query($dbh, $form);
#  
#  # taxes
#  $query = qq|SELECT c.accno
#		FROM chart c
#		JOIN partstax pt ON (pt.chart_id = c.id)
#		WHERE pt.parts_id = ?|;
#  my $tth = $dbh->prepare($query) || $form->dberror($query);
# 
#  my $taxrate;
#  my $ptref;
#  
#  while ($ref = $sth->fetchrow_hashref(NAME_lc)) {
#
#    ($decimalplaces) = ($ref->{fxsellprice} =~ /\.(\d+)/);
#    $decimalplaces = length $decimalplaces;
#    $decimalplaces = 2 unless $decimalplaces;
#  
#    $tth->execute($ref->{id});
#
#    $ref->{taxaccounts} = "";
#    $taxrate = 0;
#    
#    while ($ptref = $tth->fetchrow_hashref(NAME_lc)) {
#	$ref->{taxaccounts} .= "$ptref->{accno} ";
#	$taxrate += $form->{"$ptref->{accno}_rate"};
#    }
#    $tth->finish;
#    chop $ref->{taxaccounts};
#
#    # price matrix
#    $ref->{sellprice} = ($ref->{fxsellprice} * $form->{$form->{currency}});
#    &price_matrix($pmh, $ref, $form->{transdate}, $decimalplaces, $form, $myconfig, 1);
#    $ref->{sellprice} = $ref->{fxsellprice};
#
#    $ref->{partsgroup} = $ref->{partsgrouptranslation} if $ref->{partsgrouptranslation};
#    
#    push @{ $form->{invoice_details} }, $ref;
#  }
#  $sth->finish;
#
#  my $rc = $dbh->commit;

  return $invoice;
}

#retrieves 1 item object - based on partnumber.
#NOTE: partnumber does NOT need to be a number - but I'll just call it partnumber as SL does it :)
#if there's more than one item matching the partnumber given - well you're up shit creek - and we'll just return 1
sub getItem {
  my ($self, $partnr) = @_;
  return 1 if !$partnr;
 
  #TODO: Need to pull out income and expense tax accountno (ie. look p.id up in
  # partstax, and find the corresponding accno for the given chartid. It
  # seems the chart.category = L = incometax and chart.category = A = expensetax
  # so some sort of subselect should be added to the query to get it out in one go.
  # Also need the VatRate. Need to figure out how SL supports different vatrates
  # pr. item. Is it in itemgroups - or? there's no vatrate field in parts table.
  my $sth = $self->{_db}->prepare("SELECT p.id, p.partnumber, p.description, p.sellprice, (SELECT accno FROM chart WHERE chart.id = p.expense_accno_id) AS expense_accno,
                 p.lastcost, p.unit, pg.partsgroup, p.partsgroup_id, (SELECT accno FROM chart WHERE chart.id = p.income_accno_id) AS income_accno   
		 FROM parts p
		 LEFT JOIN partsgroup pg ON (pg.id = p.partsgroup_id) 
		 WHERE p.obsolete = '0' AND p.income_accno_id > 0 AND lower(p.partnumber) = ?");
  $sth->execute($partnr);
  my $ref = $sth->fetchrow_hashref;
  
  my $item =  eval { new Item(); }  or return 1;
  $item->map($ref);
  #done 
  return $item;
}

#retrieves an array of item objects - based on all data set in an itemobject.
sub searchItems {
  my ($self, $item) = @_;

#  my $where = "WHERE p.obsolete = '0' AND p.income_accno_id > 0";
#
#  if ($form->{"partnumber_$i"}) {
#    $var = $form->like(lc $form->{"partnumber_$i"});
#    $where .= " AND lower(p.partnumber) LIKE '$var'";
#  }
#  if ($form->{"description_$i"}) {
#    $var = $form->like(lc $form->{"description_$i"});
#    $where .= " AND lower(p.description) LIKE '$var'";
#  }
#
#  if ($form->{"partsgroup_$i"}) {
#    ($null, $var) = split /--/, $form->{"partsgroup_$i"};
#    $where .= qq| AND p.partsgroup_id = $var|;
#  }
#  
#  $sth = $self->{_db}->prepare("SELECT p.id, p.partnumber, p.description, p.sellprice,
#                 p.lastcost, p.unit, pg.partsgroup, p.partsgroup_id
#		 FROM parts p
#		 LEFT JOIN partsgroup pg ON (pg.id = p.partsgroup_id) 
#		 WHERE ");
#  $sth->execute($uid);

  return $item;
}

1;